      SUBROUTINE HZHRWCARDS
c     ------------------
c     Read control cards into the hzcontrol common block.
c     Doesn't actually read cards, but sets up keys for FFREAD.
c
c     Cards specific to HERWIG.
c
c     -------------------------
      IMPLICIT NONE

      INTEGER itmp

c  Variable and common blocks for steering parameters
#include "hzhrwcontrol.inc"

c  Initialize steering arrays to (hopefully) unlikely value so we can see
c  later which ones have been overridden in the steering cards.
c  ??? Is it really a good idea to do this here?
      DATA hzprrad,hzphrad,hzqspac,hzclmax,hzpsplt1,hzpsplt2,
     &     hzphad,hzprsof,hzbtclm,hzqcdlam,hzvqcut,hzvgcut,hzvpcut,
     &     hzptrms, hzasfixd, hzomega0, hzq2wwmx /17*-999.9/
      DATA hzioprem, hznflav, hzispac, hziflmax /4*-999/

      DO itmp=1,hzmaxproc
         hziproc(itmp)=-999
      ENDDO

c     Radius of proton
      CALL FFKEY('PRRAD',hzprrad,1,'real')

c     Radius of photon
      CALL FFKEY('PHRAD',hzphrad,1,'real')

c     QSPAC
      CALL FFKEY('QSPAC',hzqspac,1,'real')

c     Fragmentation parameters
      CALL FFKEY('CLMAX',hzclmax,1,'real')
      CALL FFKEY('PSPLT1',hzpsplt1,1,'real')
      CALL FFKEY('PSPLT2',hzpsplt2,1,'real')

c     Phad
      CALL FFKEY('PHAD',hzphad,1,'real')

      CALL FFKEY('PRSOF',hzprsof,1,'real')
      CALL FFKEY('BTCLM',hzbtclm,1,'real')

c     Lambda QCD
      CALL FFKEY('QCDLAM',hzqcdlam,1,'real')

      CALL FFKEY('VQCUT',hzvqcut,1,'real')
      CALL FFKEY('VGCUT',hzvgcut,1,'real')
      CALL FFKEY('VPCUT',hzvpcut,1,'real')

c     Intrinsic PT
      CALL FFKEY('PTRMS',hzptrms,1,'real')

c     Process selection 
      CALL FFKEY('IPROC',hziproc,hzmaxproc,'integer')

c     JIMMY generator for multiparton interactions
      CALL FFKEY('JIMMY',hzjimmy,1,'integer')
c     minimum PT of secondary scatters.
      CALL FFKEY('PTJIM',hzptjim,1,'real')
c     run in underlying event or minimum bias mode.
      CALL FFKEY('JMUEO',hzjmueo,1,'integer')

      CALL FFKEY('IOPREM',hzioprem,1,'integer')

c     parameters for colour singlet exchange (proc 2400)
      CALL FFKEY('OMEGA0',hzomega0,1,'real')
      CALL FFKEY('ASFIXD',hzasfixd,1,'real')

c     maximum q2 in ww approximation for photons
      CALL FFKEY('Q2WWMX',hzq2wwmx,1,'real')

      RETURN
      END
