      SUBROUTINE HZROUTINES(iflag,avrg)
c
c     Call the analysis routines with the appropriate flag
c
c     avrg is the mean charged multiplicity, which is required by
c     some analysis routines and should be calculated before calling
c     this subroutine for the first time.
c
c     HZTOOL conventions telling you what these routine names mean can 
c     be found at http://hztool.hep.ucl.ac.uk

      IMPLICIT NONE

#include "hzcontrol.inc"

      INTEGER iflag, iproc
      DOUBLE PRECISION avrg

cc      write (6,*) 'HZROUTINES called with iflag = ',iflag
      
      iproc = mod(iflag,10000)/1000

c     template routine
         IF (hztest) CALL hztemplate(iflag)
c     HERA
      IF (iproc.le.2) THEN
         IF (hzroutine(1)) CALL hz94176(iflag)
         IF (hzroutine(2)) CALL hz95033(iflag)
         IF (hzroutine(27)) CALL hz95219(iflag)
         IF (hzroutine(28)) CALL hz96094(iflag)
         IF (hzroutine(29)) CALL hz97164(iflag)
         IF (hzroutine(30)) CALL hz97191(iflag)
         IF (hzroutine(31)) CALL hz97196(iflag)
         IF (hzroutine(32)) CALL hz98018(iflag)
         IF (hzroutine(33)) CALL hz98085(iflag)
         IF (hzroutine(34)) CALL hz98162(iflag)
         IF (hzroutine(35)) CALL hz99057(iflag)
         IF (hzroutine(36)) CALL hz00035(iflag)
         IF (hzroutine(40)) CALL hz01220(iflag)
         IF (hzroutine(41)) CALL hzi02849(iflag)
         IF (hzroutine(42)) CALL hz01225(iflag)
         IF (hzroutine(57)) CALL hz00166(iflag)
         IF (hzroutine(60)) CALL hz02228(iflag)
         IF (hzroutine(67)) CALL hzh9505001(iflag)
         IF (hzroutine(68)) CALL hzh9810020(iflag)
         IF (hzroutine(69)) CALL hzh0302034(iflag)
         IF (hzroutine(71)) CALL hzh0006017(iflag)
         IF (hzroutine(72)) CALL hzh0312057(iflag)
c     virtual photon routine
         IF (hzroutine(76)) CALL hzh0404033(iflag)
c     virtual photon charm routine
         IF (hzroutine(77)) CALL hzh0307071(iflag)

      ENDIF

      IF (iproc.le.3) THEN
c     these routines sometimes run with colour singlet added.
         IF (hzroutine(26)) CALL hz95194(iflag)
         IF (hzroutine(58)) CALL hz02023(iflag)
      ENDIF

c     LEP
      IF (hzroutine(37)) CALL hzc96132(iflag)
      IF (hzroutine(38)) CALL hzc98113(iflag)
      IF (hzroutine(59)) CALL hzh0301013(iflag)
      IF (hzroutine(73)) CALL hzc00109(iflag)

c     Tevatron
      IF (hzroutine(39)) CALL hzf01211e(iflag)
      IF (hzroutine(51)) CALL hzh9807014(iflag)
      IF (hzroutine(52)) CALL hzh9912022(iflag)
      IF (hzroutine(53)) CALL hzh9807018(iflag)
      IF (hzroutine(62)) CALL hzf89201e(iflag,avrg)
      IF (hzroutine(63)) CALL hzplb435453(iflag,avrg)
      IF (hzroutine(65)) CALL hzh9905024(iflag)
      IF (hzroutine(70)) CALL hzh0001021(iflag)
      IF (hzroutine(74)) CALL hzh0010026(iflag)
      IF (hzroutine(75)) CALL hzh9907009(iflag)

c     SPS
      IF (hzroutine(54)) CALL hzc88172a(iflag,avrg)
      IF (hzroutine(55)) CALL hzprt154247(iflag,avrg)
      IF (hzroutine(56)) CALL hzc88172b(iflag,avrg)

cc      IF (hzroutine(61)) CALL (iflag)
cc      IF (hzroutine(64)) CALL (iflag)
cc      IF (hzroutine(66)) CALL (iflag)

      RETURN
      END
